;; Create the core HTML bits, that will be used in both
;; the stand-alone page, and the include-in-another-page page.
;; <!-- $Fuller: sgml/resume/dsssl/html-core.dsl,v 1.1.1.1 2002/01/03 05:01:50 fullermd Exp $ -->

;; First, get our helper functions
&helpers.dsl;

;; The 'heading' section
(element heading
	(make display-group
		(mktag "div class=\"headdiv\"")
		(mktag "h1 class=\"headname\"")
		(process-matching-children 'fullname)
		(newline)
		(mktag "/h1")
		(mktag "p class=\"headp\"")
		(process-matching-children 'address)
		(mktag "/p")
		(mktag "/div")
		;; XXX This is a hack, we really should do this a level up
		(mktag "ol")))

(element (heading fullname)
	(make paragraph
		(process-children)))

(element address
	(make display-group
		(process-children)))

;; Watch it, these get inherited all over the place
(element (address street)
	(make paragraph
		(process-children)
		(newline)
		(mktag "br")))

(element (address city)
	(make sequence
		(process-children)
		(literal ", ")))

(element (address state)
	(make sequence
		(process-children)
		(literal " ")))

(element (address zip)
	(make sequence
		(process-children)
		(newline)))

(element (address phone)
	(make paragraph
		(mktag "br")
		(process-children)
		(newline)))

(element (address email)
	(make sequence
		(mktag "br")
		(optag)
		(literal "a href=\"mailto:")
		(process-children)
		(literal "\"")
		(closetag)
		(process-children)
		(mktag "/a")))

(element (address url)
	(make sequence
		(mktag "br")
		(optag)
		(literal "a href=\"")
		(process-children)
		(literal "\"")
		(closetag)
		(process-children)
		(mktag "/a")))


;; Objective is pretty easy
(element objective
	(make display-group
		(mktag "li")
		(mktag "div class=\"objective\"")
		(mktag "h2")
		(literal "Objective")
		(newline)
		(mktag "/h2")
		(process-children)
		(mktag "/div")))

;; That's it for the heading, now for the work history
(element workhist
	(make display-group
		(mktag "li")
		(mktag "div class=\"workhist\"")
		(mktag "h2")
		(literal "Work history")
		(newline)
		(mktag "/h2")
		(mktag "ul")
		(process-matching-children 'job)
		(mktag "/ul")
		(mktag "/div")))

(element (workhist job)
	(make display-group
		(mktag "li")
		(process-matching-children 'company)
		(mktag "ul")
		(mktag "li")
		(mktag "p")
		(process-matching-children 'address)
		(mktag "/p")
		(mktag "li")
		(mktag "p")
		(process-matching-children 'startdate 'enddate)
		(mktag "/p")
		(mktag "li")
		(mktag "p")
		(literal "Responsibilities:")
		(newline)
		(mktag "/p")
		(process-matching-children 'responsibilities)
		(mktag "/ul")))

(element (job company)
	(make sequence
		(mktag "h3")
		(process-children)
		(mktag "/h3")))

(element startdate
	(make sequence
		(process-children)
		(literal " - ")))

(element enddate 
	(make sequence
		(process-children)
		(newline)))

(element responsibilities
	(make display-group
		(process-children)))

(element para
	(make paragraph
		(mktag "p")
		(process-children)
		(mktag "/p")))


;; Move on to 'experience'
(element experience
	(make display-group
		(mktag "li")
		(mktag "div class=\"experience\"")
		(mktag "h2")
		(process-matching-children 'type)
		(literal " Experience")
		(newline)
		(mktag "/h2")
		(mktag "ul")
		(process-matching-children 'category)
		(mktag "/ul")
		(mktag "/div")))

(element type
	(make sequence
		(process-children)))

(element (experience category)
	(make display-group
		(mktag "li")
		(process-matching-children 'type)
		(newline)
		(mktag "ul")
		(process-matching-children 'tidbit)
		(mktag "/ul")))

(element (category tidbit)
	(make display-group
		(mktag "li")
		(process-children)))


;; Then the edumakayshun section
(element education
	(make display-group
		(mktag "li")
		(mktag "div class=\"education\"")
		(mktag "h2")
		(literal "Education")
		(newline)
		(mktag "/h2")
		(mktag "ul")
		(process-matching-children 'institute)
		(mktag "/ul")
		(mktag "/div")))

(element institute
	(make display-group
		(mktag "li")
		(mktag "p")
		(process-matching-children 'name)
		(newline)
		(mktag "/p")
		(mktag "p")
		(process-matching-children 'address)
		(mktag "/p")
		(mktag "p")
		(literal "Attended: ")
		(process-matching-children 'startdate 'enddate)
		(mktag "/p")
		(mktag "p")
		(literal "Details:")
		(newline)
		(mktag "/p")
		(process-matching-children 'details)))

(element details
	(make display-group
		(process-children)))


;; And the references, which I'm not currently using
;; This has a 'disable'-like feature, for 'on-request-only'
(element references
	(make display-group
		(mktag "li")
		(mktag "div class=\"references\"")
		(mktag "h2")
		(literal "References")
		(newline)
		(mktag "/h2")
		(mktag "ul")
		(if (equal? (attribute-string "ONREQUEST") "YES")
			(make paragraph
				(mktag "li")
				(literal "References are available upon request."))
			(process-matching-children 'reference))
		(mktag "/ul")
		(mktag "/div")
		;; XXX This is a hack, we really should do this a level up
		(mktag "/ol")))

(element reference
	(make display-group
		(mktag "li")
		(mktag "p")
		(process-matching-children 'name)
		(mktag "/p")
		(mktag "p")
		(process-matching-children 'address)
		(mktag "/p")
		(mktag "p")
		(literal "Relationship: ")
		(process-matching-children 'relationship)
		(mktag "/p")
		(process-matching-children 'details)))


;; Extra stuff
;; Handle href's, they're fun
(element href
	(make sequence
		(optag)
		(literal "a href=\"")
		(literal (attribute-string "url"))
		(literal "\"")
		(closetag)
		(process-children)
		(optag)
		(literal "/a")
		(closetag)))
